<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/report_writer_.table_mgr.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>09/11/85  report_writer_.table_mgr
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>Function:  The table_manager procedure is written by the application
<span id="L4" class="LineNr">  4 </span>programmer, and is part of the application that uses report_writer_.
<span id="L5" class="LineNr">  5 </span>The table_manager procedure is responsible for retrieving rows from the
<span id="L6" class="LineNr">  6 </span>source data file <span class="textRainbow_lv0_p0">(</span>or files<span class="textRainbow_lv0_p0">)</span> that the application wishes to use in
<span id="L7" class="LineNr">  7 </span>formatting the report.
<span id="L8" class="LineNr">  8 </span>
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>Entry points in table_manager:
<span id="L11" class="LineNr"> 11 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>:Entry: create_table: 09/03/85  table_manager$create_table
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>Function:  This entry is called by report_writer_ when the display
<span id="L17" class="LineNr"> 17 </span>request is invoked with the -new_retrieval control argument <span class="textRainbow_lv0_p0">(</span>Default<span class="textRainbow_lv0_p0">)</span>.
<span id="L18" class="LineNr"> 18 </span>It performs any initialization required to perform its data retrieval
<span id="L19" class="LineNr"> 19 </span>function.  It then retrieves the first row from its source data file,
<span id="L20" class="LineNr"> 20 </span>and places it in the row_value buffer.
<span id="L21" class="LineNr"> 21 </span>
<span id="L22" class="LineNr"> 22 </span>
<span id="L23" class="LineNr"> 23 </span>Usage:
<span id="L24" class="LineNr"> 24 </span>dcl table_manager$create_table entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L25" class="LineNr"> 25 </span>call table_manager$create_table <span class="textRainbow_lv0_p0">(</span>info_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>
<span id="L28" class="LineNr"> 28 </span>Arguments:
<span id="L29" class="LineNr"> 29 </span>info_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L30" class="LineNr"> 30 </span>   is the pointer to the application's info structure that is passed to
<span id="L31" class="LineNr"> 31 </span>   the ssu_$create_invocation entrypoint by the application when the
<span id="L32" class="LineNr"> 32 </span>   ssu_ invocation is created.
<span id="L33" class="LineNr"> 33 </span>code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L34" class="LineNr"> 34 </span>   is a standard Multics error code.  If this entry finds the source
<span id="L35" class="LineNr"> 35 </span>   data file empty when the retrieval of the first row is attempted, it
<span id="L36" class="LineNr"> 36 </span>   sets this code to rw_error_$no_data.  If this entry executes
<span id="L37" class="LineNr"> 37 </span>   successfully it sets this code to zero.  If this entry encounters
<span id="L38" class="LineNr"> 38 </span>   any other problem during execution, it sets the code to indicate
<span id="L39" class="LineNr"> 39 </span>   what the source of the problem is.
<span id="L40" class="LineNr"> 40 </span>
<span id="L41" class="LineNr"> 41 </span>
<span id="L42" class="LineNr"> 42 </span>Notes:  The application's info structure must contain the row_info_ptr
<span id="L43" class="LineNr"> 43 </span>passed to report_writer_$define_columns.  This points to the row_info
<span id="L44" class="LineNr"> 44 </span>structure, which in turn points to row_value buffer.
<span id="L45" class="LineNr"> 45 </span>table_manager$create_table must move the first row of data into this
<span id="L46" class="LineNr"> 46 </span>row_value buffer, either by a PL/I assignment or substr pseudovariable,
<span id="L47" class="LineNr"> 47 </span>or by calling report_writer_$convert_and_move_row.
<span id="L48" class="LineNr"> 48 </span>
<span id="L49" class="LineNr"> 49 </span>
<span id="L50" class="LineNr"> 50 </span>:Entry: delete_table: 09/03/85  table_manager$delete_table
<span id="L51" class="LineNr"> 51 </span>
<span id="L52" class="LineNr"> 52 </span>Function:  This entry is called by report_writer_ when the formatting
<span id="L53" class="LineNr"> 53 </span>of the report is completed.  After the last data row is retrieved, it
<span id="L54" class="LineNr"> 54 </span>performs any termination steps required by the application.
<span id="L55" class="LineNr"> 55 </span>
<span id="L56" class="LineNr"> 56 </span>
<span id="L57" class="LineNr"> 57 </span>Usage:
<span id="L58" class="LineNr"> 58 </span>dcl table_manager$delete_table entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L59" class="LineNr"> 59 </span>call table_manager$delete_table <span class="textRainbow_lv0_p0">(</span>info_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span>Arguments:
<span id="L63" class="LineNr"> 63 </span>info_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L64" class="LineNr"> 64 </span>   is the pointer to the application's info structure that is passed to
<span id="L65" class="LineNr"> 65 </span>   the ssu_$create_invocation entrypoint by the application when the
<span id="L66" class="LineNr"> 66 </span>   ssu_ invocation is created.
<span id="L67" class="LineNr"> 67 </span>code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L68" class="LineNr"> 68 </span>   is a standard Multics error code.  If this entry executes
<span id="L69" class="LineNr"> 69 </span>   successfully it sets this code to zero.  If this entry encounters
<span id="L70" class="LineNr"> 70 </span>   any problem during execution, it sets the code to indicate what the
<span id="L71" class="LineNr"> 71 </span>   source of the problem is.
<span id="L72" class="LineNr"> 72 </span>
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>:Entry: get_query: 09/03/85  table_manager$get_query
<span id="L75" class="LineNr"> 75 </span>
<span id="L76" class="LineNr"> 76 </span>Function:  This entry is called by report_writer_ when the
<span id="L77" class="LineNr"> 77 </span>save_format_options request is invoked with the -query control
<span id="L78" class="LineNr"> 78 </span>argument.  It returns to report_writer_ the requests needed to select
<span id="L79" class="LineNr"> 79 </span>the data currently being displayed, so that these requests can be saved
<span id="L80" class="LineNr"> 80 </span>along with the report layout.  If the application does not support user
<span id="L81" class="LineNr"> 81 </span>requests to select data, this entrypoint should not be provided.
<span id="L82" class="LineNr"> 82 </span>
<span id="L83" class="LineNr"> 83 </span>
<span id="L84" class="LineNr"> 84 </span>Usage:
<span id="L85" class="LineNr"> 85 </span>dcl table_manager$get_query entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L86" class="LineNr"> 86 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L87" class="LineNr"> 87 </span>call table_manager$get_query <span class="textRainbow_lv0_p0">(</span>info_ptr<span class="textRainbow_lv0_o0">,</span> query_segment_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L88" class="LineNr"> 88 </span>     query_length<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L89" class="LineNr"> 89 </span>
<span id="L90" class="LineNr"> 90 </span>
<span id="L91" class="LineNr"> 91 </span>Arguments:
<span id="L92" class="LineNr"> 92 </span>info_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L93" class="LineNr"> 93 </span>   is the pointer to the application's info structure that is passed to
<span id="L94" class="LineNr"> 94 </span>   the ssu_$create_invocation entrypoint by the application when the
<span id="L95" class="LineNr"> 95 </span>   ssu_ invocation is created.
<span id="L96" class="LineNr"> 96 </span>query_segment_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L97" class="LineNr"> 97 </span>   is the pointer to a segment provided by report_writer_, where the
<span id="L98" class="LineNr"> 98 </span>   data selection requests are placed by this entrypoint.
<span id="L99" class="LineNr"> 99 </span>query_length <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L100" class="LineNr">100 </span>   is the length in characters of the returned data selection requests.
<span id="L101" class="LineNr">101 </span>   This entrypoint sets the length to let report_writer_ know how many
<span id="L102" class="LineNr">102 </span>   characters are being returned.
<span id="L103" class="LineNr">103 </span>code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L104" class="LineNr">104 </span>   is a standard Multics error code.  If this entry executes
<span id="L105" class="LineNr">105 </span>   successfully it sets this code to zero.  If this entry encounters
<span id="L106" class="LineNr">106 </span>   any problem during execution, it sets the code to indicate what the
<span id="L107" class="LineNr">107 </span>   source of the problem is.
<span id="L108" class="LineNr">108 </span>
<span id="L109" class="LineNr">109 </span>
<span id="L110" class="LineNr">110 </span>Notes:  The data selection requests are dependent on the application,
<span id="L111" class="LineNr">111 </span>and should contain whatever requests are necessary to select the data
<span id="L112" class="LineNr">112 </span>currently being displayed.  These requests are executed from within a
<span id="L113" class="LineNr">113 </span>subsystem exec_com when the saved report layout is restored by the
<span id="L114" class="LineNr">114 </span>report_writer_ restore_format_options request.  An example of data
<span id="L115" class="LineNr">115 </span>selection statments specific to the LINUS subsystem follows.
<span id="L116" class="LineNr">116 </span>
<span id="L117" class="LineNr">117 </span>   input_query -force -brief -terminal_input
<span id="L118" class="LineNr">118 </span>   select * from employee
<span id="L119" class="LineNr">119 </span>   .
<span id="L120" class="LineNr">120 </span>   translate_query
<span id="L121" class="LineNr">121 </span>
<span id="L122" class="LineNr">122 </span>If any ampersands are found within the data selection requests that
<span id="L123" class="LineNr">123 </span>would be interpreted by exec_com when the report layout is restored,
<span id="L124" class="LineNr">124 </span>they are protected by save_format_options with double ampersands before
<span id="L125" class="LineNr">125 </span>being placed in the saved report layout file.  In the case of a
<span id="L126" class="LineNr">126 </span>subsystem like LINUS, a portion of a select statement that looked like:
<span id="L127" class="LineNr">127 </span>
<span id="L128" class="LineNr">128 </span>   &amp; name = &quot;Smith&quot;
<span id="L129" class="LineNr">129 </span>
<span id="L130" class="LineNr">130 </span>would be saved as:
<span id="L131" class="LineNr">131 </span>
<span id="L132" class="LineNr">132 </span>   &amp;&amp; name = &quot;Smith&quot;
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span>
<span id="L135" class="LineNr">135 </span>:Entry: get_row: 09/03/85  table_manager$get_row
<span id="L136" class="LineNr">136 </span>
<span id="L137" class="LineNr">137 </span>Function:  This entry is called by report_writer_ when a row is needed
<span id="L138" class="LineNr">138 </span>during the formatting of the report.  It retrieves a row from its
<span id="L139" class="LineNr">139 </span>source data file and places it in the report_writer_ row value buffer.
<span id="L140" class="LineNr">140 </span>
<span id="L141" class="LineNr">141 </span>
<span id="L142" class="LineNr">142 </span>Usage:
<span id="L143" class="LineNr">143 </span>dcl table_manager$get_row entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L144" class="LineNr">144 </span>call table_manager$get_row <span class="textRainbow_lv0_p0">(</span>info_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>
<span id="L147" class="LineNr">147 </span>Arguments:
<span id="L148" class="LineNr">148 </span>info_ptr <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L149" class="LineNr">149 </span>   is the pointer to the application's info structure that is passed to
<span id="L150" class="LineNr">150 </span>   the ssu_$create_invocation entrypoint by the application when the
<span id="L151" class="LineNr">151 </span>   ssu_ invocation is created.
<span id="L152" class="LineNr">152 </span>code <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L153" class="LineNr">153 </span>   is a standard Multics error code.  If this entry executes
<span id="L154" class="LineNr">154 </span>   successfully it sets this code to zero.  If this entry encounters an
<span id="L155" class="LineNr">155 </span>   end-of-file on the source data file, it sets this code to
<span id="L156" class="LineNr">156 </span>   error_table_$end_of_info.  If this entry encounters any other
<span id="L157" class="LineNr">157 </span>   problem during execution, it sets the code to indicate what the
<span id="L158" class="LineNr">158 </span>   source of the problem is.
<span id="L159" class="LineNr">159 </span>
<span id="L160" class="LineNr">160 </span>
<span id="L161" class="LineNr">161 </span>Notes:  The application's info structure must contain the row_info_ptr
<span id="L162" class="LineNr">162 </span>passed to report_writer_$define_columns.  This points to the row_info
<span id="L163" class="LineNr">163 </span>structure, which in turn points to row_value buffer.
<span id="L164" class="LineNr">164 </span>table_manager$get_row must move the first row of data into this
<span id="L165" class="LineNr">165 </span>row_value buffer, either by a PL/I assignment or substr pseudovariable,
<span id="L166" class="LineNr">166 </span>or by calling report_writer_$convert_and_move_row.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
